#include <pybind11/pybind11.h>
#include "aidge/utils/Attributes.hpp"
#include "aidge/utils/DynamicAttributes.hpp"

namespace py = pybind11;
namespace Aidge {
void init_Attributes(py::module& m){
    py::class_<Attributes, std::shared_ptr<Attributes>>(m, "Attributes")
    .def("has_attr", &Attributes::hasAttr)
    .def("get_attr_type", &Attributes::getAttrType)
    .def("get_attrs_name", &Attributes::getAttrsName)
    .def("get_attr", &Attributes::getAttrPy, py::arg("name"));

    py::class_<DynamicAttributes, std::shared_ptr<DynamicAttributes>, Attributes>(m, "DynamicAttributes")
    .def("add_attr", &DynamicAttributes::addAttr<bool>)
    .def("add_attr", &DynamicAttributes::addAttr<int>)
    .def("add_attr", &DynamicAttributes::addAttr<float>)
    .def("add_attr", &DynamicAttributes::addAttr<std::string>)
    .def("add_attr", &DynamicAttributes::addAttr<std::vector<bool>>)
    .def("add_attr", &DynamicAttributes::addAttr<std::vector<int>>)
    .def("add_attr", &DynamicAttributes::addAttr<std::vector<float>>)
    .def("add_attr", &DynamicAttributes::addAttr<std::vector<std::string>>);
}
}

